# -*- coding: utf-8 -*-
# klassendiagrammApp.py
"""StartApp und Controller fuer Klassendiagramme"""

import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='2': print('Projekt läuft nur unter Python 3.x')

import wx
from klassendiagramme import *

### ---------------------------------------------------
class KlassendiagrammApp(wx.App):
    """Anwendung fuer Klassendiagramme"""
    def OnInit(self):
        self.gui = Gui(None, -1, "Klassendiagramme-Gui",pos=(700,50),size=(450,280))
        self.SetTopWindow(self.gui)
        self.fenster = GrafikFenster(self.gui, "Klassendiagramm",size=(800,800))
        self.fenster.Show(True)
        self.gui.Show(True)
        self.klassendiagramm=Klassendiagramm(self.gui, self.fenster)
        Zeichenflaeche.GibZeichenflaeche().BeobachterAnmelden(self.klassendiagramm)
        self.gui.SetzeController(self.klassendiagramm)
        return True

    @staticmethod
    def GibGui(): return self.gui
    @staticmethod
    def GibGrafikFenster(): return self.fenster

### ---------------------------------------------------
if __name__ == '__main__':
    app = KlassendiagrammApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()

	
