# -*- coding: utf-8 -*-
# klassenkarte.py

from klassendiagramme.figuren import *

### ---------------------------------------------------
class Klassenkarte():
    """Klassenkarte fuer UML-Diagramme"""

    def __init__(self, name, xPos=100, yPos=100,
                 attribute=[], methoden=[], abstrakt=False):
        self.__x,self.__y = xPos,yPos
        self.__name = name
        self.__istAbstrakt = abstrakt
        self.__attribute = []+attribute  ## echte Kopie !!!
        self.__methoden = []+methoden  ## echte Kopie !!!
        self.__zeilenhoehe = 20
        self.__b = 80
        self.GibFigur()
        self.__figur.Zeige()

    ## Attribute: (<Name>:String ,<Typ> unklar, <istAbstrakt>: boolean), <istKlassenvar>: boolean)
    ## Methoden: (<Name>:String ,<Typ> unklar,<[Parameter]>,<istAbstrakt>: boolean),<istKlassenm>: boolean)
    ## Klasse (Daten): <Name>:String ,<Abmessungen>:Tupel, 

    ## Get-Methoden
    def GibNamen(self): return self.__name
    def GibAttribute(self): return []+self.__attribute
    def GibMethoden(self): return []+self.__methoden
    def GibX(self): return self.__x
    def GibY(self): return self.__y
    def GibBreite(self): return self.__b
    def GibHoehe(self): return self.__h
    def GibAbmessungen(self): return self.__x,self.__y,self.__b,self.__h
    def GibDatenTextlich(self):
        '''gibt die Daten als Strings zurueck'''
        return self.GibNamen(),\
               str(self.GibAbmessungen()),\
               str(self.__attribute),\
               str(self.__methoden),\
               str(self.__istAbstrakt)
    def GibMethodeZuName(self, methodenName):
        for methode in self.__methoden:
            if methode[0]==methodenName:
                return methode
        return None
    def GibParameterZuMethName(self, methodenName):
        methode=self.GibMethodeZuName(methodenName)
        if methode==None: return None
        return methode[2]

    def AendereNamen(self,neuerName):
        '''ändert den Klassennamen'''
        self.__figur.Verberge()
        self.__name=neuerName
        self.GibFigur()
        self.__figur.Zeige()

    def AttributZeilen(self):
        '''Gibt eine Liste aus Zeilen in Strings
        fuer die Attribute zurueck'''
        attrZeilen=[]
        for i in range(len(self.__attribute)):
            zeile=self.__attribute[i][0]
            if self.__attribute[i][1]!=None:
                zeile+=' : '+str(self.__attribute[i][1])
            attrZeilen.append(zeile)
        return attrZeilen

    def MethodenZeilen(self):
        '''Gibt eine Liste aus Zeilen in Strings
        fuer die Methoden zurueck'''
        methZeilen=[]
        for i in range(len(self.__methoden)):
            zeile=self.__methoden[i][0]+'('
            for par in self.__methoden[i][2]:
                zeile+=str(par[0]+' : '+par[1])
                if par!= self.__methoden[i][2][len(self.__methoden[i][2])-1]:
                    zeile+=', '
            zeile+=')'
            if str(self.__methoden[i][1])!='None':
                zeile+=' : '+str(self.__methoden[i][1])
            methZeilen.append(zeile)
        return methZeilen

    def GibFigur(self):
        '''gibt die Figur zurueck (benoetigt die Zeichenflaeche)
        Neuentwurf 2021-05-11: Zuerst notwendige Breite bestimmen'''
        self.__figur=FigurenGruppe(self.__x,self.__y)
        zh = self.__zeilenhoehe
        zeilenlaenge=15 # Minimalwert(self.__b-10)//7
        attAnz = len(self.__attribute)
        metAnz = len(self.__methoden)
        kopfHoehe = zh
        if self.__istAbstrakt:
            kopfHoehe += zh
        attrHoehe = zh * max(attAnz, 1)
        methHoehe = zh * max(metAnz, 1)
        self.__h=kopfHoehe+attrHoehe+methHoehe
        ## Texte in den Zeilen bestimmen
        kopfZeilen=[self.__name]
        if self.__istAbstrakt: kopfZeilen.append("<<<abstract>>>")
        attrZeilen=self.AttributZeilen() # ist Dictionary!
        methZeilen=self.MethodenZeilen() # ist Dictionary!
        ## deren maximale Laenge bestimmen
        for zeile in kopfZeilen+attrZeilen+methZeilen:
            if len(zeile)>zeilenlaenge: zeilenlaenge=len(zeile)
        breite=int(zeilenlaenge*7)+10
        ##if breite>self.__b: nicht!
        self.__b=breite
        ## Felder zeichnen
        self.__figur.FuegeHinzu(Rechteck(0,0,self.__b,self.__h))
        self.__figur.FuegeHinzu(Linie(0,kopfHoehe,self.__b,0))
        self.__figur.FuegeHinzu(Linie(0,kopfHoehe+attrHoehe,self.__b,0))

        ## Kopf
        ## Zum Zentrieren des Kopfes
        dx=(self.__b-len(self.__name)*7)//2
        nameText=Text(self.__name,self.__x+dx,self.__y+3)
        if self.__istAbstrakt:
            nameText.SetzeFont(style='KURSIV')
            dx=(self.__b-len("<<<abstract>>>")*7)//2
            abstraktKennung = Text("<<<abstract>>>",self.__x+dx,self.__y+zh+3)
            abstraktKennung.SetzeFont(style='KURSIV')
            self.__figur.FuegeHinzu(abstraktKennung)
        self.__figur.FuegeHinzu(nameText)

        ## Attribute einzeichnen
        for i in range(len(attrZeilen)):
            attributZeile=Text(attrZeilen[i], self.__x+5, self.__y+3+kopfHoehe+i*zh)
            if len(self.__attribute[i])>2:
                if self.__attribute[i][2]:
                    attributZeile.SetzeFont(style='KURSIV')
                # Klassenvariable koennen nicht abstrakt sein
                elif len(self.__attribute[i])>3:
                    if self.__attribute[i][3]:
                        attributZeile.SetzeFont(underline=True)
            self.__figur.FuegeHinzu(attributZeile)
        
        ## Methoden einzeichnen
        for i in range(len(methZeilen)):
            methodenZeile=Text(methZeilen[i], self.__x+5, self.__y+3+kopfHoehe+i*zh+attrHoehe)
            if self.__methoden[i][3]:
                methodenZeile.SetzeFont(style='KURSIV')
            elif len(self.__methoden[i])>4:
                if self.__methoden[i][4]:
                    methodenZeile.SetzeFont(underline=True)
            self.__figur.FuegeHinzu(methodenZeile)                
        return self.__figur

    def GibFuellFarbe(self):
        return "WHITE"

    def IstAbstrakt(self): return self.__istAbstrakt

    ## veraendernde Methoden
    def NeueBreite(self, breite):
        '''setzt die Breite der Klassenkarte neu'''
        self.__figur.Verberge()
        self.__b = breite
        self.GibFigur()
        self.__figur.Zeige()

    def Bewege(self, x=10, y=0):
        '''bewegt die Klassenkarte'''
        self.__figur.Verberge()
        self.__x += x
        self.__y += y
        self.GibFigur()
        self.__figur.Zeige()

    def NeuesAttribut(self, name, typ=None, isAbstract=False, isClassvar=False):
        '''fuegt der Klasse ein neues Attribut hinzu'''
        self.__figur.Verberge()
        self.__attribute.append((name,typ,isAbstract,isClassvar))
        self.GibFigur()
        self.__figur.Zeige()

    def LoescheAttribut(self, name):
        for attribut in self.__attribute:
            if name==attribut[0]:
                self.__figur.Verberge()
                self.__attribute.remove(attribut)
                self.GibFigur()
                self.__figur.Zeige()
                break

    def SetzeAttributListe(self, attributliste):
        '''Wird nach einem Bearbeiten aufgerufen'''
        self.__figur.Verberge()
        self.__attribute=attributliste
        self.GibFigur()
        self.__figur.Zeige()

    def SortiereAttribute(self, liste):
        laenge=len(self.__attribute)
        if laenge!=len(liste): return
        for i in range(1,laenge+1):
            if not(i in liste): return
        neueAttributliste=[]
        for i in range(laenge):
            neueAttributliste.append(self.__attribute[liste[i]-1])
        self.SetzeAttributListe(neueAttributliste)

    def NeueMethode(self, name, typ=None, par=[],
                    istAbstrakt=False, isStaticMethod=False):
        '''fuegt der Klasse eine neue Methode hinzu'''
        self.__figur.Verberge()
        self.__methoden.append((name,typ,par,istAbstrakt,isStaticMethod))
        self.GibFigur()
        self.__figur.Zeige()

    def LoescheMethode(self, name):
        for methode in self.__methoden:
            if name==methode[0]:
                self.__figur.Verberge()
                self.__methoden.remove(methode)
                self.GibFigur()
                self.__figur.Zeige()
                break

    def LoescheParameter(self, methodenName, parameterName):
        neueMethodenListe=[]
        methodeZuName=None
        for methode in self.GibMethoden():
            if methode[0]==methodenName:
                neueParameterliste=[]
                for parameter in methode[2]:
                    if parameter[0]!=parameterName:
                        neueParameterliste.append(parameter)
                neu=(methode[0],methode[1],neueParameterliste)+methode[3:]
                neueMethodenListe.append(neu)
            else:
                neueMethodenListe.append(methode)
        self.SetzeMethodenListe(neueMethodenListe)

    def SetzeMethodenListe(self, methodenliste):
        '''Wird nach einem Bearbeiten aufgerufen'''
        self.__figur.Verberge()
        self.__methoden=methodenliste
        self.GibFigur()
        self.__figur.Zeige()

    def SortiereMethoden(self, liste):
        laenge=len(self.__methoden)
        if laenge!=len(liste): return
        for i in range(1,laenge+1):
            if not(i in liste): return
        neueMethodenliste=[]
        for i in range(laenge):
            neueMethodenliste.append(self.__methoden[liste[i]-1])
        self.SetzeMethodenListe(neueMethodenliste)

    def SortiereParameter(self, methodenName, liste):
        methode=None
        gefunden=False
        vorMethoden,nachMethoden=[],[]
        for m in self.__methoden:
            if m[0]==methodenName:
                methode=m
                gefunden=True
            elif gefunden:
                nachMethoden.append(m)
            else:
                vorMethoden.append(m)
        if not(gefunden): return
        parameter=methode[2]
        laenge=len(parameter)
        if laenge!=len(liste): return
        for i in range(1,laenge+1):
            if not(i in liste): return
        neueParameterliste=[]
        for i in range(laenge):
            neueParameterliste.append(parameter[liste[i]-1])
        geaenderteMethode=(methode[0],methode[1],
                           neueParameterliste,
                           methode[3],methode[4])
        neueMethodenliste=vorMethoden+[geaenderteMethode]+nachMethoden
        self.SetzeMethodenListe(neueMethodenliste)

    def SetzeAbstrakt(self, abstrakt):
        self.__figur.Verberge()
        self.__istAbstrakt=abstrakt
        self.GibFigur()
        self.__figur.Zeige()

    def ExportiereBild(self, dateiname='Klassenkarte.png'):
        '''exportiert das Bild der Klassenkarte
        ToDo: nur Ausschnitt speichern'''
        Zeichenflaeche.GibZeichenflaeche().BildExport(dateiname)

    def Verberge(self):
        self.__figur.Verberge()
    
    def Zeige(self):
        self.__figur.Zeige()        
    
### ---------------------------------------------------
class KlassenkarteApp(wx.App):
    """Test-Anwendung nicht fuer Paket geeignet"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Klassenkarte")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.TestAnwendung()
        self.__fenster.ZeigeShellFrame()
        ##self.TestParameter()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def TestAnwendung(self):
        """Test-Methode fuer Klassenkarten"""
        global karte1,karte2,karte3
        karte1=Klassenkarte('Testklasse')
        karte1.NeuesAttribut('xPosition','int')
        karte1.NeuesAttribut('yPosition','int')
        karte1.NeuesAttribut('b','int')
        karte1.NeuesAttribut('h','int')
        karte1.NeueMethode('Bewege',None,[('umX','int'),('umY','int')])
        karte1.Bewege(-50,100)
        karte2=Klassenkarte('ZweiteKlasse',200)
        karte2.NeueMethode('Bewege',None,[('umX','int')])
        karte2.NeueMethode('Drehe',None,[('umW','int')])
        karte2.NeueMethode('Skaliere',None,[('umF','float')])
        karte2.SetzeAbstrakt(True)
        karte3=Klassenkarte('DritteKlasse')
        karte3.Bewege(-100,-100)
        karte3.NeueMethode('Bewege',None,[('umX','int'),('umY','int'),('umZ','int')])
        print(karte1.GibDatenTextlich())
        print(karte2.GibDatenTextlich())

    def TestSortiereAttribute(self):
        """Test-Methode fuer Parameter"""
        global karte1,karte2,karte3
        karte1.SortiereAttribute([3,4,1,2])
        
    def TestSortiereMethoden(self):
        """Test-Methode fuer Parameter"""
        global karte1,karte2,karte3
        karte2.SortiereMethoden([3,1,2])
        
    def TestSortiereParameter(self):
        """Test-Methode fuer Parameter"""
        global karte1,karte2,karte3
        karte3.SortiereParameter("Bewege",[3,1,2])

    def TestLoescheParameter(self):
        global karte1
        karte1.LoescheParameter('Bewege','umX')
        print(karte1.GibDatenTextlich())
### ---------------------------------------------------
if __name__ == '__main__':
    app = KlassenkarteApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
